'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

/**
 * Adds the 'hover' class to cells above and to the left of the current cell
 * This is used to "fill in" the grid that the user will change the layout to,
 * if they click on a specific table cell.
 *
 * @param currentCell
 */

/*function highlightCells(currentCell) {
    var cells = $('.layoutChooser table td');
    cells.removeClass('hover');

    currentCell = $(currentCell);
    var table = currentCell.parents('.layoutChooser table').get(0);
    var rowIndex = currentCell.closest('tr').index();
    var columnIndex = currentCell.index();

    // Loop through the table row by row
    // and cell by cell to apply the highlighting
    for (var i = 0; i < table.rows.length; i++) {
        row = table.rows[i];
        if (i <= rowIndex) {
           for (var j = 0; j < row.cells.length; j++) {
                if (j <= columnIndex) {
                    cell = row.cells[j];
                    cell.classList.add('hover');
                }
           }
        }
    }
}*/

/*Template.layoutChooser.events({
    'touchstart .layoutChooser table td, mouseenter .layoutChooser table td': function(evt) {
        highlightCells(evt.currentTarget);
    },
    'click .layoutChooser table td': function(evt) {
        var currentCell = $(evt.currentTarget);
        var rowIndex = currentCell.closest('tr').index();
        var columnIndex = currentCell.index();

        // Add 1 because the indices start from zero
        var layoutProps = {
            rows: rowIndex + 1,
            columns: columnIndex + 1
        };

        layoutManager.layoutTemplateName = 'gridLayout';
        layoutManager.layoutProps = layoutProps;
        layoutManager.updateViewports();
    }
});*/

var LayoutChooser =
/*#__PURE__*/
function (_Component) {
  _inherits(LayoutChooser, _Component);

  function LayoutChooser() {
    _classCallCheck(this, LayoutChooser);

    return _possibleConstructorReturn(this, _getPrototypeOf(LayoutChooser).apply(this, arguments));
  }

  _createClass(LayoutChooser, [{
    key: "render",
    value: function render() {
      var rows = this.props.rows;
      var columns = this.props.columns;
      var style = {
        display: this.props.visible ? 'block' : 'none'
      };
      return React__default.createElement("div", {
        className: "LayoutChooser pull-left dropdown-menu",
        role: "menu",
        style: style
      }, React__default.createElement("table", null, React__default.createElement("tbody", null, _toConsumableArray(Array(rows)).map(function (row, i) {
        return React__default.createElement("tr", {
          key: i
        }, _toConsumableArray(Array(columns)).map(function (column, j) {
          return React__default.createElement("td", {
            style: {
              width: '20px',
              height: '20px',
              border: 'solid 1px black'
            },
            key: j
          });
        }));
      }))));
    }
  }]);

  return LayoutChooser;
}(React.Component);

_defineProperty(LayoutChooser, "defaultProps", {
  rows: 4,
  columns: 4,
  visible: false
});

_defineProperty(LayoutChooser, "propTypes", {
  rows: PropTypes.number.isRequired,
  columns: PropTypes.number.isRequired,
  visible: PropTypes.bool.isRequired
});

var LayoutButton =
/*#__PURE__*/
function (_Component) {
  _inherits(LayoutButton, _Component);

  function LayoutButton(props) {
    var _this;

    _classCallCheck(this, LayoutButton);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LayoutButton).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function () {
      _this.setState({
        dropdownVisible: !_this.state.dropdownVisible
      });
    });

    _this.state = {
      dropdownVisible: props.dropdownVisible
    };
    return _this;
  }

  _createClass(LayoutButton, [{
    key: "render",
    value: function render() {
      return React__default.createElement("div", {
        className: "btn-group"
      }, React__default.createElement("button", {
        id: "layout",
        type: "button",
        className: "btn btn-sm btn-default dropdown-toggle",
        "data-container": "body",
        "data-toggle": "dropdown",
        "aria-expanded": "false",
        "data-placement": "right",
        title: "Layout",
        rel: "tooltip",
        onClick: this.onClick
      }, React__default.createElement("span", {
        className: "fa fa-th-large"
      })), React__default.createElement(LayoutChooser, {
        visible: this.state.dropdownVisible
      }));
    }
  }]);

  return LayoutButton;
}(React.Component);

_defineProperty(LayoutButton, "defaultProps", {
  dropdownVisible: false
});

_defineProperty(LayoutButton, "propTypes", {
  dropdownVisible: PropTypes.bool.isRequired
});

exports.LayoutButton = LayoutButton;
//# sourceMappingURL=index.js.map
